NIPALS.PCA <-
function(X,lamx,penalty){
   eps.cov<-1
   n<-dim(X)[1]
   p<-dim(X)[2]
   
   v1<-X[,1]
   a1<-rep(10^-3,p) 
   
   niter<-0
   w<-30
   svd.X<-svd(X)
   sigx<- sd(svd.X$v[,1])/sqrt(2) ## Woojoo's method 
   
   while ((eps.cov>1e-03)&(niter<100)){
     
   eps.conv.a1<-1

   eps.conv.sig<-1
   
       niter.a1<-0
        
       while ( (eps.conv.a1>1e-02) & (niter.a1<50) ){
      
       kax <- sqrt(4*a1^2/(w*sigx^2)+((2/w)-1)^2)
       
       ## w30
       if (penalty=="HL") {uux <- 0.25*w*(((2/w)-1)+kax)+0.000000001}
       
       #Lasso
       if (penalty=="Lasso") {uux <- abs(a1)+0.000000001} 
       
       ##SCAD
       if (penalty=="SCAD") {uux <- (abs(a1)+0.000000001)/(as.numeric(abs(a1)<=lamx)+as.numeric(abs(a1)>lamx)* as.numeric(3.7*lamx>abs(a1))*(3.7*lamx-abs(a1))/((3.7-1)*lamx))   }

       WWx<-as.vector(1/uux)
       a1.old<-a1
    
       v1.norm<-as.numeric(t(v1)%*%v1)
       Xtv1<-t(X)%*%v1
            
            for (i in 1:p){
            a1[i]<-(1/(v1.norm+lamx*WWx[i]))%*%Xtv1[i]
            }
       
       eps.conv.a1<-max(abs(a1-a1.old))
           
       niter.a1<-niter.a1+1
       }
    
   a1.norm<-sum(a1^2)
   a1<-a1/sqrt(a1.norm)
   v1.old<-v1
   v1<-X%*%a1

   eps.cov<-max(abs(v1-v1.old))
   niter<-niter+1
   }
   
   a1<-a1/sqrt(sum(a1^2)) ## normalization
   v1<-X%*%a1
   
   #if (niter>=100) {print("No Convergence")}
   return(list(v1=v1,a1=round(a1,digit=4),WWx=WWx,niter=niter,eps.cov=eps.cov,sigx=sigx))
}

