Shrink.cond <-
function(X,kmax){

    n<-dim(X)[1]
    p<-dim(X)[2]
    
    S<-t(X)%*%X/n
    
    svd.S<-svd(S)
    U<-svd.S$u
    D<-svd.S$d ## 
    V<-svd.S$v ## 
    
    L<-D ## eigen value of sample covariance matrix
     
    a<-1;b<-2;lb<-1/L[1]
    fact<-TRUE
    
    u_star<- NaN 
    
    while (is.na(u_star) ==TRUE){
    
        if (fact==TRUE) { while ( a<b & b<=p & 1/(kmax*L[b])<= 1/L[a]){ b<-b+1 }
                          if (1/(kmax*L[b])<1/L[a+1]) {ub<-1/(kmax*L[b]) ; fact2<-FALSE}
                                           else {ub<-1/L[a+1]; a<-a+1; fact2<-TRUE} 
                        }                                   
        
        if (fact==FALSE) { while ( a<b & b<=p & 1/L[a+1]<=1/(kmax*L[b-1])) { a<-a+1 }
                           if (1/(kmax*L[b])<1/L[a+1]) {ub<-1/(kmax*L[b+1]); b<-b+1; fact2<-FALSE}
                                           else  {ub<-1/L[a+1]; fact2<-TRUE}
                         }
                  
        fact<-fact2
        
        if (b>p) {break}
        
        u_temp<-(a+p-b+1)/(sum(L[1:a])+kmax*sum(L[b:p]))
        
        if ((lb<=u_temp) & (u_temp<=ub)) {u_star<-u_temp}                                 
        
        else {lb<-ub}
        
    }
    
    mu<-rep(0,p)
    
    u<-u_star
    
    for ( i in 1:p){
    
        mu[i] <-min( max(u,1/L[i]), kmax*u)
    }
    
    return(mu)

}

