cv.lamx <-
function(X,penalty){


kk<-5 ## 5-fold CV

n<-dim(X)[1]
h <- n/kk  
cv.set <- matrix(0,kk,h)
    
    for(i in 1:kk){
            cv.set[i,] <- kk*c(1:h)-(kk-i)
    }   

mm <- 200;lam <- seq(0.1, 100,,mm) 
    
var.pc<- rep(0,mm) ## variance of PCs 
    
       
    for(i in 1:mm){       
         
        X.k <- NULL
        
        var.k<-rep(0,kk)
            
        for(k in 1:kk) {
        
            X.ok <- X[-cv.set[k,],]   
            
            
            pc.k<-NIPALS.PCA(X.ok, lam[i], penalty)
            
            X.k <- X[cv.set[k,],]
            
            var.k[k]<-var(X.k%*%pc.k$a1)
                                   
        }
        
        var.pc[i]<- 1/kk*sum(var.k)
    
    }
    
ind.cv <- (1:mm)[which.max(var.pc)]

lamx <- lam[ind.cv]

return(list(lamx=lamx, var.pc=var.pc))
}

